C----------------------------------------------------------------------
C
C  Example program for obtaining distributions with a 
C  dis-shapes-mc data file for the fixed-order contributions.
C
C  $Id: example_withdsm.f,v 1.8 2001/09/19 15:09:17 salam Exp $
C----------------------------------------------------------------------
      program example_withdsm
      !--- defines all the symbolic constants that are needed ---------
      !use driver_withdsm
      implicit none
      !--- have the following two lines if not using driver_withdsm ---
      include 'disresum_constants.inc'
      double precision dg_asValue
      !-----------------------------------------------------------
      integer FOE_handle_lo, FOE_handle_hi
      integer EvshpId, FOE_handle
      double precision xbj,ybj,Q
      !-- not used for now
      !double precision muF_Q
      !integer pdf_id, FactScheme, nf
      !-- for getting distribution
      integer nbin, ibin
      parameter(nbin=21)
      double precision varvals(nbin), sigmavals(nbin)
      double precision alfas, alfa0, muR_Q, mu, muI, normfact
      integer MatchType, EvlnType, PowerType

      ! initialise all the fixed-order distributions from the stated file
      ! and set up matching information for the given variable.
      
      call dwd_start('h1-fixeds.top',EvshpId_rho_E,
     $                                  FOE_handle_lo,FOE_handle_hi)

      ! The FOE_handles are then used for accessing individual x,Q values.
      write(0,*) 'Available fixed order sets are:'
      write(0,'(a10,3a18,a10)') 'FOE_handle','xbj','ybj','Q','EvshpId'
      do FOE_handle = FOE_handle_lo, FOE_handle_hi
         call dwd_info(FOE_handle, xbj,ybj,Q,EvshpId)
         !call dwd_extrainfo(FOE_handle, pdf_id, muF_Q, factscheme, nf)
         write(0,'(i10,3f18.10,i10)') FOE_handle, xbj,ybj,Q,EvshpId
      end do

      !----- set up the parameters for our distribution ------
      ! muR / Q
      muR_Q = 1d0
      alfa0 = 0.5d0
      muI   = 2.0d0 ! standard choice...
      call dg_asInit(0.118d0)
      MatchType = MatchType_Mmod
      EvlnType  = EvlnType_NLO        ! not needed for rho
      PowerType = PowerType_modshift
      
      !------ now generate a distribution ---------------------
      ! first set up variable values
      do ibin = 1, nbin
         varvals(ibin) = (ibin-1) * 0.25d0 / (nbin-1)
      end do

      !-- call to get the distribution
      do FOE_handle = FOE_handle_lo, FOE_handle_hi
         call dwd_info(FOE_handle, xbj,ybj,Q,EvshpId)
         mu = muR_Q * Q
         alfas = dg_asValue(mu)
         call dwd_dist(FOE_handle,nbin,varvals,sigmavals,
     $        alfas,  muR_Q, alfa0, muI, MatchType, EvlnType, PowerType)
         
         normfact = (10d0)**(FOE_handle - FOE_handle_lo)
         do ibin = 1, nbin-1
            write(6,*) 0.5d0*(varvals(ibin+1) + varvals(ibin)),
     $           (sigmavals(ibin+1) - sigmavals(ibin)) *normfact/ 
     $           (varvals(ibin+1) - varvals(ibin))
         end do
         write(6,*) 
         write(6,*) 

      end do

      end
