
program ppp
  use types; use consts_dp; 
  use conv_objects; use parton_distributions; use convolution
  use evolution
  use alfas_server
  implicit none
  type(as_handle)  :: ash
  type(grid_def)   :: gd
  real(dp), pointer :: q0(:,:), q1(:,:),q2(:,:), dq(:,:)
  real(dp), pointer :: dqLL(:,:), dqNL(:,:), dqCTEQ(:,:)
  integer :: i, id, ipdf
  integer :: n = 300, nQ = 100
  real(dp) :: f, y, dy, Q2a, Q2b, Q2c, as2pi, res
  real(dp) :: Qlo, Qhi, Q
  type(PMat) :: PLO, PNLO

  
!!$  call mh_sum_rules(8.549926280_dp)
!!$  stop
  dy = 0.02_dp
  call conv_InitGridDef(gd,dy,5.0_dp)
  call cobj_InitSplitLO(gd,PLO)
  call cobj_InitSplitNLO(gd,PNLO)


!!$  ipdf = pdf_MRS98LO + 1
!!$  call as_init(ash, alfas=0.125_dp, nloop=1)
  ipdf = pdf_MRS99 + 1
  call as_init(ash, alfas=0.1175_dp, nloop=2)
!!$  !call as_init(ash, alfas=0.125_dp, nloop=1)
!!$  ipdf = pdf_CTEQ5L
!!$  call as_init(ash, alfas=0.127_dp, nloop=1)
!!$  ipdf = pdf_CTEQ5M1
!!$  call as_init(ash, alfas=0.118_dp, nloop=2)

  call pdf_InitDist(gd,dqLL,  sqrt(Q2c),pdf_ZERO)
  call pdf_InitDist(gd,dqNL,  sqrt(Q2c),pdf_ZERO)
  call pdf_InitDist(gd,dqCTEQ,sqrt(Q2c),pdf_ZERO)

  id = 1
  Qlo = 50.0_dp; Qhi = 100.0_dp
  

  y = 5d0
  do i = 0, nQ
     Q = Qlo + i*(Qhi-Qlo)/nQ
     Q2b = Q**2
     Q2a = Q2b * 0.98_dp; Q2c = Q2b / 0.98_dp; 

     call pdf_InitDist(gd,q0,sqrt(Q2a),ipdf)
     call pdf_InitDist(gd,q1,sqrt(Q2b),ipdf)
     call pdf_InitDist(gd,q2,sqrt(Q2c),ipdf)
     
     as2pi = as_value(ash,sqrt(Q2b)) / twopi
     dqCTEQ = (q2-q0)/(log(Q2c/Q2a) * as2pi)
     dqLL = (PLO .conv. q1)
     dqNL = dqLL + as2pi * (PNLO .conv. q1)
     
     write(6,'(10f20.10)') Q,&
          &        conv_EvalGridQuant(gd,q1(:,id),y),&
          &        conv_EvalGridQuant(gd,dqLL(:,id),y),&
          &        conv_EvalGridQuant(gd,dqNL(:,id),y),&
          &        conv_EvalGridQuant(gd,dqCTEQ(:,id),y)
  end do

end program ppp
