!======================================================================
! Test parsing
program main_parse
  use types; use consts_dp; use qcd
  !-- for some obscure reason osf likes to have conv_objects
  !   come before the rest...
  use conv_objects
  use parser; use holders; use convolution; use parton_distributions
  use fo_evshp
  use event_shapes
  implicit none
  type(grid_def) :: gd
  type(fixed_order_set)  :: set
  type(fixed_order_evshp), pointer :: array(:)
  type(fixed_order_evshp), pointer :: evshp 
  type(sigma_holder)    :: sh
  type(gdval) :: xx
  integer :: n,i
  real(dp) :: xmin
  real(dp), pointer :: pdf(:,:)

  write(0,*) '---------- parsing ------------'
  !-----------------------------------------
  call parser_ReadFile(5, set)
  write(0,*) 'nf is', set%nf
  call qcd_SetNf(set%nf)
  call qcd_SetGroup(set%ca, set%cf, set%tr)
  !-----------------------------------------
  call foe_ListToArray(set%first, array, es_ids=(/EvshpId_tau_zQ, EvshpId_tau_zE/))
  n = size(array)
  xmin = minval(array%xbj)

  write(0,*) '--------- Initialising splitting functions -------'
  call conv_InitGridDef(gd,dy=0.02_dp, ymax=-log(xmin))
  call holder_InitSigma(gd,sh, factscheme = set%factscheme)

  n = size(array)
  do i = 1, n
     evshp => array(i)
     call pdf_InitDist(gd, pdf, Qval=evshp%Q, iset = evshp%pdf_id)
     write(6,*) '------------'
     write(6,*) evshp%xbj, evshp%ybj, evshp%pdf_id
     write(6,*) evshp%sigma(2),'+-',evshp%sigerr(2)
     
     xx = gd .with. evshp%xbj
     !write(6,*) ((sh%C2_1.conv.pdf) .atx. xx) / ((sh%C2.conv.pdf) .atx. xx)
     write(6,*) cobj_Eval2LConv(sh%C2_1,sh%CL_1,pdf,evshp%xbj, evshp%ybj)&
          &         / ((sh%C2.conv.pdf) .atx. xx)
  end do
  
end program main_parse
