!======================================================================
! Test parsing
program main_parse
  use types; use consts_dp; use qcd
  !-- for some obscure reason osf likes to have conv_objects
  !   come before the rest...
  use conv_objects; use convolution; use holders; use parton_distributions
  use event_shapes; use matching
  implicit none
  !--------------------------------------------
  real(dp), pointer       :: pdf(:,:)
  type(grid_def)          :: gd
  type(sigma_holder)      :: sh
  type(eventshape_holder) :: esh
  type(match_holder)      :: mh

  call conv_InitGridDef(gd, 0.2_dp, 10.0_dp)
  call holder_InitSigma(gd, sh)
  call holder_InitEventShape(esh, sh, EvshpId_tau_tE)
  call pdf_InitDist(gd, pdf, 100.0_dp, pdf_ZERO)

  call ma_InitMatchHolder(mh,sh,esh,pdf,0.01_dp,0.01_dp, muF_Q=one, Q=100.0_dp)

end program main_parse
