! $Id: qcd.f90,v 1.3 2001/04/20 09:48:56 salam Exp $
module qcd
  use types; use consts_dp

  integer,  parameter :: nf_def = 5
  real(dp), parameter :: ca_def = 3, cf_def = four/three, tr_def = half
  real(dp), parameter :: tf_def = tr_def * nf_def

  !-- the following are all modifiable, but have default values
  real(dp), public :: ca = ca_def
  real(dp), public :: cf = cf_def
  real(dp), public :: tr = tr_def

  integer,  public :: nf_int = nf_def
  integer,  public :: nf_u = nf_def/2
  integer,  public :: nf_d = (nf_def+1)/2
  real(dp), public :: nf = nf_def, tf = tf_def
  ! HACK TO GET GLUON + SINGLET EVOLUTION in 0 & 1
  ! For it to work, quark component in 2 must be zero.
  !integer, parameter, public :: nf_u = nf_def, nf_d = 0

  real(dp), public :: beta0 = (11*ca_def - four*tf_def)/(12*pi)
  real(dp), public :: twopi_beta0 = (11*ca_def - four*tf_def)/6.0_dp
  real(dp), public :: beta1 = (17*ca_def**2 - tf_def*(10*ca_def + 6*cf_def))&
       &                        / (24*pisq)
  real(dp), public :: cmw_K = ca_def*(67.0_dp/18.0_dp - pisq/6.0_dp) &
       &                      - tf_def * 10.0_dp/9.0_dp

  integer, parameter, public :: factscheme_MSbar   = 1
  integer, parameter, public :: factscheme_DIS     = 2
  integer, parameter, public :: factscheme_default = factscheme_MSbar


  public :: qcd_SetNf, qcd_SetGroup
  
contains

  !----------------------------------------------------------------------
  subroutine qcd_SetNf(nf_in)
    integer :: nf_in
    nf_int = nf_in
    nf     = nf_int
    nf_u   = nf_int/2
    nf_d   = (nf_int+1)/2
    tf     = tr * nf
    call qcd_set_beta0
  end subroutine qcd_SetNf
  
  !----------------------------------------------------------------------
  subroutine qcd_SetGroup(ca_in,cf_in,tr_in)
    real(dp), intent(in) :: ca_in,cf_in,tr_in
    ca = ca_in
    cf = cf_in
    tr = tr_in
    tf = nf * tr
    call qcd_set_beta0
  end subroutine qcd_SetGroup

  !----------------------------------------------------------------------
  subroutine qcd_set_beta0
    beta0       = (11*ca - four*tf)/(12*pi)
    twopi_beta0 = twopi * beta0
    beta1       = (17*ca**2 - tf*(10*ca + 6*cf)) / (24*pisq)
    cmw_K       = ca*(67.0_dp/18.0_dp - pisq/6.0_dp) - tf * 10.0_dp/9.0_dp
  end subroutine qcd_set_beta0
  


end module qcd
