program test_brd
  use types; use consts_dp
  use brdzE; use sub_defs_io; use qcd
  implicit none

  real(dp) :: Lambda, rp, power
  real(dp) :: bigL, as, dummy, asbar
  real(dp) :: ell, Lambdabar, Lambdabar_g, Lambdabar_m, expnsn
  real(dp) :: LambdaBar_20, LambdaBar_21, LambdaBar_22
  real(dp) :: LambdaBar_20_g, LambdaBar_21_g
  real(dp), parameter :: brd_zE_X12 = 1.945031318_dp
  real(dp) :: Lbar, LambdaBar_gamma, Rp_eff_m, Rp_eff 
  real(dp) :: a,b,c


  integer :: i
  rp = dble_val_opt('-rp')
  Lambda = brdzE_Lambda(rp)
  write(6,*) 'Lambda:', rp, Lambda*(4-rp)
  Lambda = brdzE_Lambda_Itrplt(Rp) 
  write(6,*) Lambda*(4-rp)
  !---
  power = brdzE_Power(Rp)
  write(6,*) 'Power:', rp, power
  power = brdzE_Power_Itrplt(Rp)
  write(6,*) power

  stop

  power = brdzE_Power(Rp)
  write(6,*) power, power + 0.6137056_dp
  write(6,*) (brdzE_Power(3.9999_dp) - brdzE_Power(3.9998_dp))/1e-4_dp
  write(6,*) (brdzE_Power(four) - brdzE_Power(3.9999_dp))/1e-4_dp
  write(6,*) (brdzE_Power(four) - brdzE_Power(3.99999_dp))/1e-5_dp

  !--
  write(6,*) 'steps of 10^-3'
  a = (brdzE_Power(3.9975_dp) - brdzE_Power(3.9965_dp))/1e-3_dp
  b = (brdzE_Power(3.9985_dp) - brdzE_Power(3.9975_dp))/1e-3_dp
  write(6,*) (brdzE_Power(3.9975_dp) - brdzE_Power(3.9965_dp))/1e-3_dp
  write(6,*) (brdzE_Power(3.9985_dp) - brdzE_Power(3.9975_dp))/1e-3_dp
  write(6,*) (brdzE_Power(3.9995_dp) - brdzE_Power(3.9985_dp))/1e-3_dp
  write(6,*) (brdzE_Power(four) - brdzE_Power(3.999_dp))/1e-3_dp
  write(6,*) 'extrap:', b + 2*(b-a)
  write(6,*) 'steps of 2*10^-3'
  a = (brdzE_Power(3.996_dp) - brdzE_Power(3.994_dp))/2e-3_dp
  b = (brdzE_Power(3.998_dp) - brdzE_Power(3.996_dp))/2e-3_dp
  write(6,*) 'extrap:', b + 1.5_dp*(b-a)
  write(6,*) (brdzE_Power(3.996_dp) - brdzE_Power(3.994_dp))/2e-3_dp
  write(6,*) (brdzE_Power(3.998_dp) - brdzE_Power(3.996_dp))/2e-3_dp
  write(6,*) (brdzE_Power(four) - brdzE_Power(3.998_dp))/2e-3_dp
  stop

!!$  bigL = dble_val_opt('-L')
!!$  ell = -half*bigL
  !Lambdabar = brdzE_LambdaBar(as, bigL, ell)
  as   = dble_val_opt('-as')
!!$  !do i = 1, 630
  do i = 5800, 6500,5
     bigL = i*1e-4_dp/as
     !ell = brdzE_ell(as, bigL)
     !Lambdabar = brdzE_LambdaBar(as, bigL, ell)
     !Lambdabar_m = brdzE_LambdaBar_m(as, bigL, ell)
     !write(6,'(4es18.9)') bigl*as, ell, Lambdabar, Lambdabar_m/Lambdabar
     call brdzE_LambdaEffInfo(as,bigL,Lbar,LambdaBar,LambdaBar_gamma,&
          &Rp_eff, minimal=.false.)
     call brdzE_LambdaEffInfo(as,bigL,Lbar,LambdaBar,LambdaBar_gamma,&
          &Rp_eff_m, minimal=.true.)
     write(6,*) bigl*as, Rp_eff, Rp_eff_m
  end do


  stop

  !-- test lambdabar_m expansion

  LambdaBar_20 = three/10.0_dp*CF**2*pisq**2& ! standard piece
       & - 8*CF*zeta3*beta0*pi &! this piece is associated with R'''
       & +(four*eulergamma-three)*CF**2*(3*zeta3) !R2gp in Lmbdbar
!       & +(-three*CF)*CF*(3*zeta3) !R2gp in Lmbdbar
!       & +(four*eulergamma)*CF*(3*zeta3) !R2gp in Lmbdbar
  LambdaBar_21 = four/three*CF*(&
       & -two*pi**3*beta0+9.0_dp*CF*zeta3+6*CF*brd_zE_X12)&
       & +(four*eulergamma-three)&
       &     *CF**2*(-one+7*pisq/6.0_dp-two*ln2**2) !R2gp in Lmbdbar
!       &+(four*eulergamma)&
!       &+(-three*CF)&
  LambdaBar_22 = two/three*(7*pisq-36*ln2**2-6.0_dp)*CF**2
  LambdaBar_20_g = (two)*CF*(3*zeta3)
  LambdaBar_21_g = (two)*CF*(-one+7*pisq/6.0_dp-two*ln2**2)

  as   = dble_val_opt('-as')
  asbar = as / twopi
  do i = 1, 20
     bigL = i*1e-1_dp
     ell = brdzE_ell(as, bigL)
     Lambdabar = brdzE_LambdaBar(as, bigL, ell,LambdaBar_g)
!!$     expnsn = one-pisq/8.0_dp*CF*asbar +&
!!$          &asbar**2*((pisq/two-four)*CF**2*bigL**2 - pisq*pi*beta0*CF*bigL&
!!$          &          +5*pisq**2/128 * CF**2)
     expnsn = one + asbar**2*(LambdaBar_20 &
          &+ LambdaBar_21*bigL + LambdaBar_22*bigL**2)
     write(6,*) bigL, Lambdabar, expnsn
!!$     expnsn = asbar**2*(LambdaBar_20_g + LambdaBar_21_g*bigL)
!!$     write(6,*) bigL, Lambdabar_g, expnsn
     !Lambdabar_ln = brdzE_LambdaBar_ln(as, bigL, ell)
     !write(6,'(4es18.9)') bigl, Lambdabar, Lambdabar_ln/Lambdabar
  end do
  
end program test_brd
